#ifndef __ABAC_PL_YY_H__
#define __ABAC_PL_YY_H__

/* C declarations */
#include "abac_pl.h"
#include "abac_list.h"
#include "abac_util.h"
#include "abac_rt.h"

typedef struct _abac_yy_principal_t abac_yy_principal_t;
typedef struct _abac_yy_term_principal_t abac_yy_term_principal_t;
typedef struct _abac_yy_term_data_t abac_yy_term_data_t;
typedef struct _abac_yy_term_t abac_yy_term_t;
typedef struct _abac_yy_role_t abac_yy_role_t;
typedef struct _abac_yy_oset_t abac_yy_oset_t;
typedef struct _abac_yy_expression_t abac_yy_expression_t;

enum expr_rtype {
    e_yy_EXPR_NAMED=1,
    e_yy_EXPR_ROLE=2,
    e_yy_EXPR_OSET=3,
    e_yy_EXPR_LINKED=4,
    e_yy_EXPR_OBJECT=5
};

enum dterm_type {
    e_yy_DTERM_PRINCIPAL=1,
    e_yy_DTERM_NAMED=2,
    e_yy_DTERM_DATA=3,
    e_yy_DTERM_ANONYMOUS=4
};

enum range_type {
   e_yy_RANGE_MIN=1,
   e_yy_RANGE_MAX=2,
   e_yy_RANGE_TARGET=3 
};

#endif /* __ABC_PL_YY_H__ */
